//
//  Document.swift
//  TreeOutlinerSwift
//
//  Created by narita on 2017/10/13.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class TO2Document: NSDocument
{
    // MARK: - class methods
    override class var autosavesInPlace: Bool
    {
        return false
    }

    override class var autosavesDrafts: Bool
    {
        return false
    }

    // MARK: - init methods

    override init()
    {
        super.init()
        
        self.rootNode = TO2Node()
    }

    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    override func data(ofType typeName: String) throws -> Data
    {
        let theData = NSKeyedArchiver.archivedData(withRootObject: self.rootNode!)
        
        return theData
    }
    
    override func read(from data: Data, ofType typeName: String) throws
    {
        self.rootNode = NSKeyedUnarchiver.unarchiveObject(with: data) as! TO2Node?

        if self.rootNode == nil
        {
            throw NSError(domain: NSOSStatusErrorDomain, code: unimpErr, userInfo: nil)
        }
    }
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    // MARK: - action methods
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)

    @objc var rootNode: TO2Node? = nil
    
    // MARK: - Utility methods

    override func makeWindowControllers()
    {
        // Returns the Storyboard that contains your Document window.
        let storyboard = NSStoryboard(name: NSStoryboard.Name("TO2WindowController"), bundle: nil)
        
        let windowController = storyboard.instantiateController(withIdentifier:
                                    NSStoryboard.SceneIdentifier("Document Window Controller")) as! NSWindowController
        
        self.addWindowController(windowController)
        
        // ここで、コンテンツデータをViewControllerへ渡す。
        windowController.contentViewController?.representedObject = self
    }
}

