//
//  TO2ViewController+Actions.swift
//  TreeOutlinerSwift
//
//  Created by narita on 2017/10/19.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

extension TO2ViewController : NSUserInterfaceValidations
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    @IBAction func add(_ sender: Any?)
    {
        self.treeController!.add(sender)
    }
    
    @IBAction func remove(_ sender: Any?)
    {
        self.treeController!.remove(sender)
    }
    
    @IBAction func addChild(_ sender: Any?)
    {
        self.treeController!.addChild(sender)
    }
    
    @IBAction func cut(_ sender: Any?)
    {
        self.copy(sender)
        self.remove(sender)
    }
    
    @IBAction func copy(_ sender: Any?)
    {
        if let theSelectedNodes = self.treeController?.value(forKeyPath:
            "selectedNodes.representedObject") as! Array<TO2Node>?
        {
            let thePB = NSPasteboard.general
            
            thePB.clearContents()
            thePB.setData(NSKeyedArchiver.archivedData(withRootObject: theSelectedNodes),
                          forType: TO2Node.TO2NodesPasteboardType)
        }
    }
    
    @IBAction func paste(_ sender: Any?)
    {
        let thePB = NSPasteboard.general
        if let theData = thePB.data(forType: TO2Node.TO2NodesPasteboardType)
        {
            if let theArray = NSKeyedUnarchiver.unarchiveObject(with: theData) as! Array<TO2Node>?
            {
                // 選択の末尾を算定
                var theInsertIndexPath: IndexPath
                
                if self.treeController!.selectionIndexPaths.isEmpty
                {
                    theInsertIndexPath = IndexPath(index: (self.treeController?.arrangedObjects.children?.count)!)
                }
                else
                {
                    theInsertIndexPath = (self.treeController!.selectionIndexPaths.last?.indexPathByIncrementLastIndex())!
                }
                
                let theIndexPaths: Array<IndexPath> = theInsertIndexPath.incrementalIndexPaths(at: theArray.count)
                
                self.treeController!.insert(theArray, atArrangedObjectIndexPaths: theIndexPaths)
                
                self.treeController!.setSelectionIndexPaths(theIndexPaths)
            }
        }
    }
    
    @IBAction func delete(_ sender: Any?)
    {
        self.remove(sender)
    }

        func validateUserInterfaceItem(_ item: NSValidatedUserInterfaceItem) -> Bool
    {
        let theAction: Selector = item.action!
        
        switch theAction
        {
            case #selector(TO2ViewController.add(_:)):
                return self.treeController!.canAdd
            
            case #selector(TO2ViewController.remove(_:)):
                return self.treeController!.canRemove
            
            case #selector(TO2ViewController.addChild(_:)):
                return self.treeController!.canAddChild
            
            case #selector(TO2ViewController.cut(_:)):
                return
                    (self.treeController?.selectedObjects.count != 0)
                        &&
                        (NSPasteboard.general.types!.contains(TO2Node.TO2NodesPasteboardType))
            
            case #selector(TO2ViewController.copy(_:)):
                return self.treeController?.selectedObjects.count != 0
            
            case #selector(TO2ViewController.paste(_:)):
                return NSPasteboard.general.types!.contains(TO2Node.TO2NodesPasteboardType)
            
            case #selector(TO2ViewController.delete(_:)):
                return self.treeController!.canRemove
            
            case #selector(TO2ViewController.jumpbarMenu(_:)):
                return true
            
            default:
                return false
        }
    }

    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - Utility methods
    
}
